/* Process model C form file: Applica1.pr.c */
/* Portions of this file Copyright (C) MIL 3, Inc. 1992 */



/* OPNET system definitions */
#include <opnet.h>
#include "Applica1.pr.h"
FSM_EXT_DECS



/* Header block */
#define	PK_ARR	op_intrpt_type () == OPC_INTRPT_STRM
#define	SELF_INT0	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 0)
#define	SELF_INT1	(op_intrpt_type () == OPC_INTRPT_SELF  && op_intrpt_code () == 1)

#define END_SIM		op_intrpt_type () ==  OPC_INTRPT_ENDSIM

#define data_sent	0

#define ON				1
#define OFF				0

#define VL				if(ON)
#define MADL			if(ON)

#define IGMP_STREAM		0
#define IP_STREAM		1

#define UDP_PROTOCOL_ID	20

#define MAX_INIT_TIME	20

typedef struct {
	char Message[500];
}App_Data;

typedef struct{
	int NetNum;
	int NodeNum;
}IPAddress;



/* State variable definitions */
typedef struct
	{
	FSM_SYS_STATE
	Objid	                  		sv_my_id;
	Objid	                  		sv_ip_objid;
	int	                    		sv_grp_id;
	int	                    		sv_sess;
	double	                 		sv_tim;
	double	                 		sv_data_rec;
	int                     		sv_dest_net;
	int                     		sv_dest_node;
	int                     		sv_data_len;
	int                     		sv_ngrps;
	Distribution*           		sv_grp_dist;
	Distribution*           		sv_time_dist;
	Distribution*           		sv_term_dist;
	double                  		sv_sessmin;
	double                  		sv_sessmax;
	double                  		sv_data_iat;
	double                  		sv_sess_iat;
	double                  		sv_data_send;
	IPAddress               		sv_LocalAddress;
	} Applica1_state;

#define pr_state_ptr            		((Applica1_state*) SimI_Mod_State_Ptr)
#define my_id                   		pr_state_ptr->sv_my_id
#define ip_objid                		pr_state_ptr->sv_ip_objid
#define grp_id                  		pr_state_ptr->sv_grp_id
#define sess                    		pr_state_ptr->sv_sess
#define tim                     		pr_state_ptr->sv_tim
#define data_rec                		pr_state_ptr->sv_data_rec
#define dest_net                		pr_state_ptr->sv_dest_net
#define dest_node               		pr_state_ptr->sv_dest_node
#define data_len                		pr_state_ptr->sv_data_len
#define ngrps                   		pr_state_ptr->sv_ngrps
#define grp_dist                		pr_state_ptr->sv_grp_dist
#define time_dist               		pr_state_ptr->sv_time_dist
#define term_dist               		pr_state_ptr->sv_term_dist
#define sessmin                 		pr_state_ptr->sv_sessmin
#define sessmax                 		pr_state_ptr->sv_sessmax
#define data_iat                		pr_state_ptr->sv_data_iat
#define sess_iat                		pr_state_ptr->sv_sess_iat
#define data_send               		pr_state_ptr->sv_data_send
#define LocalAddress            		pr_state_ptr->sv_LocalAddress




/* Process model interrupt handling procedure */



void
Applica1 ()
	{
	Packet*  pkptr;
	int in_strm,da1,da2,da3;
	FILE*  fil;
	


	FSM_ENTER (Applica1)

	FSM_BLOCK_SWITCH
		{
		/*---------------------------------------------------------*/
		/** state (init) enter executives **/
		FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init")
			{
			
			my_id = op_id_self();
			
			ip_objid = op_topo_assoc (my_id, OPC_TOPO_ASSOC_OUT, OPC_OBJMTYPE_MODULE, IP_STREAM);
			
			op_ima_obj_attr_get (ip_objid, "net_num0", &LocalAddress.NetNum );
			op_ima_obj_attr_get (ip_objid, "node_num0", &LocalAddress.NodeNum );
			
			data_rec = 0;
			
			op_ima_obj_attr_get(my_id,"NGRPS",&ngrps);
			op_ima_obj_attr_get(my_id,"SESSMIN",&sessmin);
			op_ima_obj_attr_get(my_id,"SESSMAX",&sessmax);
			op_ima_obj_attr_get(my_id,"DATA_IAT", &data_iat);
			op_ima_obj_attr_get(my_id,"SESS_IAT",&sess_iat);
			
			/*generate a RV between 0 and 99 (max of 100 grps to 
			select which grp id to join*/
			grp_dist = op_dist_load("uniform_int",0,ngrps);
			
			/*time when he joins initially*/
			time_dist = op_dist_load("exponential",sess_iat,0);
			tim = op_dist_outcome(time_dist);
			op_intrpt_schedule_self((op_sim_time() + tim/100 + MAX_INIT_TIME),0);
			sess = 0;
			
			/*op_ima_obj_attr_get (op_id_self (), "GRP",&grp_id);*/
			
			term_dist = op_dist_load("uniform",sessmin,sessmax);
			
			
			}


		/** state (init) exit executives **/
		FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init")
			{
			}


		/** state (init) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (idle) enter executives **/
		FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle")
			{
			}


		/** blocking after enter executives of unforced state. **/
		FSM_EXIT (3,Applica1)


		/** state (idle) exit executives **/
		FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "idle")
			{
			}


		/** state (idle) transition processing **/
		FSM_INIT_COND (SELF_INT0)
		FSM_TEST_COND (END_SIM)
		FSM_TEST_COND (SELF_INT1)
		FSM_TEST_LOGIC ("idle")

		FSM_TRANSIT_SWITCH
			{
			FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
			FSM_CASE_TRANSIT (1, 4, state4_enter_exec, ;)
			FSM_CASE_TRANSIT (2, 3, state3_enter_exec, ;)
			}
		/*---------------------------------------------------------*/



		/** state (JOIN_TERM) enter executives **/
		FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "JOIN_TERM")
			{
			if( !sess )
			{
				/*
				** Join into a session  if the application is not currently in any multicast 
				** session. Schedule an interupt for terminating this session. Also schedule 
				** an interrupt for  sending data to this session. If you  are a application 
				** that  do not want to send any data donot schedule the interrupt 1 ( which 
				** is the data send interrupt) 
				*/
				grp_id =  op_dist_outcome(grp_dist); 
			
				pkptr = op_pk_create_fmt("MC_APP_CNTRL");
			
				op_pk_nfd_set( pkptr,"join",1 );
				op_pk_nfd_set( pkptr,"terminate",0 );
				op_pk_nfd_set( pkptr,"GRP_ID",grp_id );
				op_pk_send( pkptr, IGMP_STREAM );
				VL	MADL	
				{
					printf("Sending a join pk from Application \n");
				}
				sess=1; 
			
				/*Interrupt for sending data pks to the session */
				op_intrpt_schedule_self( (op_sim_time() + data_iat), 1 );
			
				/* Interrupt for terminating the existing session */
				tim = op_dist_outcome(term_dist); 
				printf("Termination time is %f\n", tim );
				op_intrpt_schedule_self( (op_sim_time() + tim), 0 );
			}
			else
			{ 
				/* 
				** Terminate the current existing session and schedule an interrupt for 
				** joining another session 
				*/
				pkptr = op_pk_create_fmt("MC_APP_CNTRL");
				op_pk_nfd_set( pkptr,"join",0 );
				op_pk_nfd_set( pkptr,"terminate",1 );
				op_pk_nfd_set( pkptr,"GRP_ID",grp_id );
				op_pk_send( pkptr,IGMP_STREAM );
				sess--;
			
				tim = op_dist_outcome(time_dist);
				op_intrpt_schedule_self( (op_sim_time() + tim), 0 );
			}
			}


		/** state (JOIN_TERM) exit executives **/
		FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "JOIN_TERM")
			{
			}


		/** state (JOIN_TERM) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (data) enter executives **/
		FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "data")
			{
			if( sess )
			{ 
				/*
				** If currently registered with a session, send an data packet to the session. 
				** Size of the data packet is 576 bytes. This data packet is encapsulated into
				** an IP packet and sent to the IP layer. The Destiantion net in the IP packet
				** is set  to the mulitcast address( 500 ) and the  destination node in the IP 
				** packet is the  Mulitcast Group ID of  the session that it is sending packet 
				** to. Interrupt is schedule for sending the next data packet.
				*/
			
				App_Data DataSent;
				Packet* ip_pkptr;
				sprintf( DataSent.Message, "This was data sending to the host %d.%d by %d.%d \n",
			             dest_net, dest_node, LocalAddress.NetNum, LocalAddress.NodeNum );
			    pkptr = op_pk_create_fmt("Unicast_Appl");
			 
			    op_pk_nfd_set(pkptr, "UniData", &DataSent, op_prg_mem_alloc,
			                  op_prg_mem_free, sizeof(App_Data) );
			 
			    data_len = op_pk_total_size_get( pkptr )/8;
			    ip_pkptr = op_pk_create_fmt("ip_dgram");
			    op_pk_nfd_set(ip_pkptr, "data", pkptr );
			    op_pk_nfd_set(ip_pkptr, "prot_id", UDP_PROTOCOL_ID );
			    op_pk_bulk_size_set(ip_pkptr, data_len*8 );
				op_pk_nfd_set(ip_pkptr, "dest_net", 500 );
				op_pk_nfd_set(ip_pkptr, "dest_node", grp_id );
				
				op_pk_nfd_set(ip_pkptr, "src_net", LocalAddress.NetNum );
			    op_pk_nfd_set(ip_pkptr, "src_node", LocalAddress.NodeNum );
			
				op_pk_nfd_set(ip_pkptr, "orig_len", data_len );
			    op_pk_nfd_set(ip_pkptr, "frag_len", data_len );
			    op_pk_nfd_set(ip_pkptr, "ttl", 2 );
			    op_pk_nfd_set(ip_pkptr, "frag", 0 );
			
				data_send++;
				op_stat_local_write( data_sent, data_send);
			
				op_pk_send(ip_pkptr, IP_STREAM);
			}
			
			/* Interrupt for the next data packet */
			op_intrpt_schedule_self( (op_sim_time() + data_iat), 1 );
			}


		/** state (data) exit executives **/
		FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "data")
			{
			}


		/** state (data) transition processing **/
		FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (End_Sim) enter executives **/
		FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "End_Sim")
			{
			}


		/** state (End_Sim) exit executives **/
		FSM_STATE_EXIT_FORCED (4, state4_exit_exec, "End_Sim")
			{
			}


		/** state (End_Sim) transition processing **/
		FSM_TRANSIT_MISSING ("End_Sim")
		/*---------------------------------------------------------*/



		}


	FSM_EXIT (0,Applica1)
	}




void
Applica1_svar (prs_ptr,var_name,var_p_ptr)
	Applica1_state		*prs_ptr;
	char			*var_name, **var_p_ptr;
	{

	FIN (Applica1_svar (prs_ptr))

	*var_p_ptr = VOS_NIL;
	if (Vos_String_Equal ("my_id" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_my_id);
	if (Vos_String_Equal ("ip_objid" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_ip_objid);
	if (Vos_String_Equal ("grp_id" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_grp_id);
	if (Vos_String_Equal ("sess" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sess);
	if (Vos_String_Equal ("tim" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_tim);
	if (Vos_String_Equal ("data_rec" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_data_rec);
	if (Vos_String_Equal ("dest_net" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_dest_net);
	if (Vos_String_Equal ("dest_node" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_dest_node);
	if (Vos_String_Equal ("data_len" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_data_len);
	if (Vos_String_Equal ("ngrps" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_ngrps);
	if (Vos_String_Equal ("grp_dist" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_grp_dist);
	if (Vos_String_Equal ("time_dist" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_time_dist);
	if (Vos_String_Equal ("term_dist" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_term_dist);
	if (Vos_String_Equal ("sessmin" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sessmin);
	if (Vos_String_Equal ("sessmax" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sessmax);
	if (Vos_String_Equal ("data_iat" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_data_iat);
	if (Vos_String_Equal ("sess_iat" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_sess_iat);
	if (Vos_String_Equal ("data_send" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_data_send);
	if (Vos_String_Equal ("LocalAddress" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_LocalAddress);

	FOUT;
	}




void
Applica1_diag ()
	{
	Packet*  pkptr;
	int in_strm,da1,da2,da3;
	FILE*  fil;
	

	FIN (Applica1_diag ())


	FOUT;
	}




void
Applica1_terminate ()
	{
	Packet*  pkptr;
	int in_strm,da1,da2,da3;
	FILE*  fil;
	

	FIN (Applica1_terminate ())


	FOUT;
	}



Compcode
Applica1_init (pr_state_pptr)
	Applica1_state			**pr_state_pptr;
	{
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	FIN (Applica1_init (pr_state_pptr))

	if (obtype == OPC_NIL)
		{
		if (Vos_Catmem_Register ("proc state vars (Applica1)",
			sizeof (Applica1_state), Vos_Nop, &obtype) == VOSC_FAILURE)
			FRET (OPC_COMPCODE_FAILURE)
		}

	if ((*pr_state_pptr = (Applica1_state*) Vos_Catmem_Alloc (obtype, 1)) == OPC_NIL)
		FRET (OPC_COMPCODE_FAILURE)
	else
		{
		(*pr_state_pptr)->current_block = 0;
		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



